import re
import json
import numpy as np
import pandas as pd

word_class_map1 = {
    "名词":[1],
    "动词":[2,3,49,50,51,133,134,135,136,212,426],
    "代词":[4,5,6,53,54,55,138,213,288,361,427,428],
    "数词":[7,57],
    "量词":[8,58,59,60,139,140,214,215,289,362,363,429],
    "副词":[9,10,11,12,13,14,61,62,63,64,65,66,67,68,142,143,144,145,146,147,148,149,216,217,218,219,220,221,222,223,290,291,292,293,294,295,364,365,366,367,368,369,370,430,519,520,521,522,523,524,525,528,529,530,531,532,533,534,535,536,537,538,543,544,545,546,547,548,549,550,551,557,558,559,560,561,562,563,564,565,566,567,568,569,570,571],
    "介词":[15,16,17,18,69,70,71,72,73,74,75,76,150,151,152,153,154,155,156,157,158,159,224,225,226,227,228,229,296,297,298,299,300,301,371,372,373,374,375,376,377,431,552,553,554,555,556],
    "连词":[19,77,78,160,230,231,302,378,379,432,433],
    "助词":[20,21,22,79,80,81,82,83,232,303,380,381,434,572,573],
    "形容词":[56],
    "叹词":[84,233],
    "拟声词":[161]
}

word_class_map2 = {
    "方位名词":[1],
    "能愿动词":[2,3,49,50,51,133,134,212,426],
    "疑问代词":[4,53,427],
    "人称代词":[5,54,213],
    "指示代词":[6,55,138,288,361,428],
    "数词":[7,57],
    "名量词":[8,58,139,214,289,362,429],
    "程度副词":[9,61,142,216,290,364,519,520,521,522,523,524,525],
    "范围、协同副词":[10,62,143,217,291,365,528,529,530,531],
    "时间副词":[11,63,144,218,292,366,548,549,550,551],
    "频率、重复副词":[12,64,145,219,293,537,538],
    "关联副词":[13,65,146,220,367,430],
    "否定副词":[14,221,535,536],
    "引出时间、处所":[15,16,69,150,151,224,296,371],
    "引出对象":[17,18,73,74,75,153,154,225,226,227,373,374,552,553],
    "连接词或词组":[19,77,230,378,432],
    "结构助词":[20,79,380,434],
    "动态助词":[21,80],
    "语气助词":[22,82,381,572,573],
    "形容词重叠":[56],
    "动量词":[59,140,363],
    "时量词":[60],
    "方式副词":[66,147,294,368,532,533,534],
    "情态副词":[67,148,222,369,543,544,545,546,547],
    "语气副词":[68,149,223,295,370,557,558,559,560,561,562,563,564,565,566,567,568,569,570,571],
    "引出方向、路径":[70,71,72,152,372,431],
    "引出目的、原因":[76,155,156,297,375],
    "连接分句或句子":[78,160,231,302,379,433],
    "助词":[81],
    "其他助词":[83,232,303],
    "叹词":[84,233],
    "离合词":[135,136],
    "引出施事、受事":[157,298],
    "表示排除":[158,376],
    "引出凭借、依据":[159,228,229,299,300,301,377,554,555,556],
    "拟声词":[161],
    "借用量词":[215]
}

class_class_map = {
    "其他": "其他",
    "方位名词": "名词",
    "能愿动词": "动词",
    "疑问代词": "代词",
    "人称代词": "代词",
    "指示代词": "代词",
    "数词": "数词",
    "名量词": "量词",
    "程度副词": "副词",
    "范围、协同副词": "副词",
    "时间副词": "副词",
    "频率、重复副词": "副词",
    "关联副词": "副词",
    "否定副词": "副词",
    "引出时间、处所": "介词",
    "引出对象": "介词",
    "连接词或词组": "连词",
    "结构助词": "助词",
    "动态助词": "助词",
    "语气助词": "助词",
    "形容词重叠": "形容词",
    "动量词": "量词",
    "时量词": "量词",
    "方式副词": "副词",
    "情态副词": "副词",
    "语气副词": "副词",
    "引出方向、路径": "介词",
    "引出目的、原因": "介词",
    "连接分句或句子": "连词",
    "助词": "助词",
    "其他助词": "助词",
    "叹词": "叹词",
    "离合词": "动词",
    "引出施事、受事": "介词",
    "表示排除": "介词",
    "引出凭借、依据": "介词",
    "拟声词": "拟声词",
    "借用量词": "量词"
}

word_patterns = {
    "1":"^([上下里外前后左右东南西北]|上边|下边|里边|外边|前边|后边|左边|右边|东边|南边|西边|北边)$",
    "2":"^[会能]$",
    "3":"^[想要]$",
    "4":"^(多|多少|几|哪|哪儿|哪里|哪些|什么|谁|怎么)$",
    "5":"^([我你您他她]|我们|你们|他们|她们)$",
    "6":"^(这|那|这儿|那儿|这里|那里|这些|那些|别的|有的)$",
    "7":"^[一二两三四五六七八九零十百半]$",
    "8":"^[杯本个家间口块页]$",
    "9":"^(非常|[很太真最])$",
    "10":"^(都|一块儿|一起)$",
    "11":"^(马上|先|有时|在|正|正在)$",
    "12":"^(常|常常|再)$",
    "13":"^[还也]$",
    "14":"^(别|不|没|没有)$",
    "15":"^从$",
    "16":"^在$",
    "17":"^[跟和]$",
    "18":"^比$",
    "19":"^(跟|还是|和)$",
    "20":"^[的地]$",
    "21":"^了$",
    "22": "^[吧了吗呢]$",
    "49": "^(可能|可以)$",
    "50": "^(该|应该)$",
    "51": "^愿意$",
    "53": "^(多久|为什么|怎么样|怎样)$",
    "54": "^(别人|大家|它|它们|咱|咱们|自己)$",
    "55": "^(那么|那样|这么|这样)$",
    "56": "^([一-龥])\\1$|^([一-龥])\\1([一-龥])\\2$",
    "57": "^[千万亿]$",
    "58": "^[层封件条位]$",
    "59": "^[遍次场回下]$",
    "60": "^(分钟|年|天|周)$",
    "61": "^(多|多么|好|更|十分|特别|挺|有一*点儿)$",
    "62": "^(全|一共|只)$",
    "63": "^(刚|刚刚|还|忽然|一直|已经)$",
    "64": "^(重新|经常|老|老是|又)$",
    "65": "^就$",
    "66": "^故意$",
    "67": "^(必须|差不多|好像|也许)$",
    "68": "^(才|都|就|正好)$",
    "69": "^当$",
    "70": "^往$",
    "71": "^向$",
    "72": "^从$",
    "73": "^对$",
    "74": "^给$",
    "75": "^离$",
    "76": "^为$",
    "77": "^(或|或者)$",
    "78": "^(不过|但|但是|而且|那|如果|虽然|只要)$",
    "79": "^得$",
    "80": "^过$",
    "81": "^着$",
    "82": "^(啊|吧|的)$",
    "83": "^(的话|等)$",
    "84": "^喂$",
    "133": "^敢$",
    "134": "^需要$",
    "135": "^(帮忙|点头|放假|干杯|见面|结婚|看病|睡觉|洗澡|理发|说话)$",
    "136": "^(打开|看见|离开|完成)$",
    "138": "^(各|各位|各种|每|任何)$",
    "139": "^(把|行|架|群|束|双|台|张|支|只|种)$",
    "140": "^(顿|口|眼)$",
    "142": "^(比较|更加|还|相当)$",
    "143": "^(光|仅|仅仅|就|至少)$",
    "144": "^(本来|才|曾经|从来|赶紧|赶快|立刻|连忙|始终|已|早已)$",
    "145": "^(通常|往往|总|总是)$",
    "146": "^再$",
    "147": "^(互相|尽量|亲自|相互)$",
    "148": "^(大概|恐怕)$",
    "149": "^(白|并|当然|到底|反正|根本|果然|简直|绝对|难道|其实|千万|确实|只好|终于)$",
    "150": "^由$",
    "151": "^自从$",
    "152": "^朝$",
    "153": "^为$",
    "154": "^向$",
    "155": "^(由于|因为)$",
    "156": "^为了$",
    "157": "^(把|被|叫|让)$",
    "158": "^除了$",
    "159": "^(按|按照)$",
    "160": "^(并且|不光|不仅|另外|要是|因此|由于|只有)$",
    "161": "^哈哈$",
    "212": "^得$",
    "213": "^人家$",
    "214": "^(打|袋|根|卷|棵|批)$",
    "215": "^(碗|脸|手|屋子|桌子|刀|针)$",
    "216": "^(格外|极|极其)$",
    "217": "^共$",
    "218": "^(按时|即将|急忙|渐渐|尽快)$",
    "219": "^(一再|再三)$",
    "220": "^却$",
    "221": "^未必$",
    "222": "^(几乎|似乎)$",
    "223": "^(的确|反而|还|竟然|究竟)$",
    "224": "^自$",
    "225": "^对于$",
    "226": "^关于$",
    "227": "^替$",
    "228": "^根据$",
    "229": "^作为$",
    "230": "^(并|以及)$",
    "231": "^(此外|而|而是|既然|可见|甚至|假如|总之)$",
    "232": "^似的$",
    "233": "^啊$",
    "288": "^(彼此|如此)$",
    "289": "^(册|朵|幅|届|颗|匹|扇)$",
    "290": "^(过于|可|稍|稍微|尤其)$",
    "291": "^大都$",
    "292": "^(不时|将|将要|仍旧|时常|时刻|依旧|一向)$",
    "293": "^(偶尔|再次)$",
    "294": "^偷偷$",
    "295": "^(毕竟|不免|差一*点儿|倒是|干脆|就|居然|可|明明|总算)$",
    "296": "^随着$",
    "297": "^将$",
    "298": "^由$",
    "299": "^凭$",
    "300": "^依据$",
    "301": "^依照$",
    "302": "^(从而|加上|完了|一旦)$",
    "303": "^也好$",
    "361": "^(本|此)$",
    "362": "^(餐|串|滴|副|股|集|枝)$",
    "363": "^(番|声|趟)$",
    "364": "^(特|异常)$",
    "365": "^(尽|净|一齐|一同)$",
    "366": "^(时时|一时|早晚)$",
    "367": "^便$",
    "368": "^(不禁|赶忙|亲眼|特地|特意)$",
    "369": "^仿佛$",
    "370": "^(才|刚好|偏|恰好)$",
    "371": "^于$",
    "372": "^沿着*$",
    "373": "^(同|与)$",
    "374": "^至于$",
    "375": "^因$",
    "376": "^除$",
    "377": "^据$",
    "378": "^(而|同|与)$",
    "379": "^(不料|可|若)$",
    "380": "^所$",
    "381": "^(罢了|啦|嘛)$",
    "426": "^需$",
    "427": "^何$",
    "428": "^(该|另|兹)$",
    "429": "^(栋|粒|枚|则|盏|人次)$",
    "430": "^亦$",
    "431": "^顺着$",
    "432": "^及$",
    "433": "^(继而|要不是)$",
    "434": "^之$",
    "519": "^极为$",
    "520": "^尽$",
    "521": "^蛮$",
    "522": "^颇$",
    "523": "^稍稍$",
    "524": "^尤为$",
    "525": "^越发$",
    "528": "^凡$",
    "529": "^皆$",
    "530": "^统统$",
    "531": "^唯独$",
    "532": "^不由得$",
    "533": "^一连$",
    "534": "^顺便$",
    "535": "^未$",
    "536": "^勿$",
    "537": "^频频$",
    "538": "^再度$",
    "543": "^必定$",
    "544": "^不妨$",
    "545": "^何必$",
    "546": "^莫非$",
    "547": "^按说$",
    "548": "^即$",
    "549": "^历来$",
    "550": "^尚$",
    "551": "^向来$",
    "552": "^当着$",
    "553": "^就$",
    "554": "^趁$",
    "555": "^基于$",
    "556": "^依$",
    "557": "^白白$",
    "558": "^反倒$",
    "559": "^分明$",
    "560": "^怪不得$",
    "561": "^好在$",
    "562": "^乃$",
    "563": "^难怪$",
    "564": "^偏偏$",
    "565": "^索性$",
    "566": "^万万$",
    "567": "^未免$",
    "568": "^无非$",
    "569": "^幸好$",
    "570": "^幸亏$",
    "571": "^终究$",
    "572": "^而已$",
    "573": "^矣$",
}

sent_patterns = {
    "93": "还是.+吧",
    "94": "又.+又.+",
    "95": "在*.+(以前|以后|前|后)",
    "115": "只要.+，就.+",
    "117": "一.+就.+",
    "129": "该.+了",
    "130": "要.+了|快要.+了|就要.+了",
    "164": "不[一-龥]不[一-龥]",
    "165": "看起来",
    "166": "看上去",
    "167": "有的是",
    "168": "除了.+(以外)*，.+(还|也|都).+",
    "169": "从.+起",
    "170": "对.+来说",
    "171": "一.+(也|都)(不|没).+",
    "172": "越.+越.+",
    "190": "也*.+，也.+",
    "191": "一会儿.+，一会儿.+",
    "192": "一方面.+，另一方面.+",
    "193": "又.+，又.+",
    "194": "首先.+，然后.+",
    "195": ".+，并且.+",
    "196": "(不仅|不光).+，(还|而且).+",
    "197": "不是.+，就是.+",
    "198": ".+([一-龥]+)是\\1，(就是|不过).+",
    "199": "要是.+，就.+",
    "200": "只有.+，才.+",
    "201": "(由于)*.+，(所以|因此).+",
    "202": "为了.+，.+",
    "203": ".+了.+就*.+",
    "234": "大[一-龥]大[一-龥]",
    "235": "一[一-龥]一[一-龥]",
    "236": "看来",
    "237": "来得及|来不及",
    "238": "说不定",
    "239": "一般来说",
    "241": "自*.+以来",
    "242": "由.+组成",
    "243": "在.+方面",
    "244": "在.+(上|下|中)",
    "254": "不是.+，而是.+",
    "255": "既.+，(又|也).+",
    "256": "首先.+，其次.+",
    "257": ".+，于是.+",
    "258": ".+，甚至.+",
    "259": "或者.+，或者.+",
    "260": ".+，然而.+",
    "261": ".+，否则.+",
    "262": "假如.+，就*.+",
    "263": "万一.+，就*.+",
    "264": "不管.+，(都|也).+",
    "265": "无论.+，(都|也).+",
    "266": "既然.+，就.+",
    "267": ".+，可见.+",
    "268": "哪怕.+，(也|还).+",
    "269": ".+，好.+",
    "271": "不.+也.+",
    "278": "不([一-龥]{1,2})白不\\1",
    "280": "没*有什么好*[一-龥]{1,2}的",
    "281": "([一-龥]{1,2})是\\1，([一-龥]{1,2})是\\2",
    "282": "([一-龥]{1,2})也得\\1，不\\1也得\\1",
    "283": "[一-龥]{1,2}就是了",
    "284": "还[一-龥]{1,2}呢",
    "285": "你[一-龥]{1,2}你的吧",
    "286": "(让|叫)你([一-龥]{1,2})你就\\1",
    "287": "(说什么|怎么着*)也得[一-龥]+",
    "304": "([一-龥])来\\1去",
    "305": "([一-龥])着\\1着",
    "306": "没[一-龥]没[一-龥]",
    "307": "说([一-龥])就\\1",
    "308": "有[一-龥]有[一-龥]",
    "309": "不得了",
    "310": "不敢当",
    "311": "得了",
    "312": "用不着",
    "313": "从.+来看",
    "314": "到.+为止",
    "315": "够.+的",
    "316": "拿.+来说",
    "317": "([一-龥])的\\1，([一-龥])的\\2",
    "318": "在.+看来",
    "331": "或是.+，或是.+",
    "332": "尽管.+，(但是|可是).+",
    "333": "一旦.+，就.+",
    "334": "要是.+，就*.+，否则.+",
    "335": "除非.+，才.+",
    "336": "除非.+，(否则|不然).+",
    "337": ".+，因而.+",
    "338": "即使.+，也.+",
    "339": ".+，为的是.+",
    "340": ".+，以便.+",
    "341": "没有.+就没有.+",
    "342": "再.+也.+",
    "347": "[一-龥]{1,2}也不是，[一-龥]{1,2}也不是",
    "348": "([一-龥]{1,2})也\\1不得，([一-龥]{1,2})也\\2不得",
    "349": "[一-龥]+是它，[一-龥]+也是它",
    "350": "([一-龥]{1,2})着也是\\1着",
    "351": "([一-龥]+)归\\1，([一-龥]+)归\\2",
    "352": "不管怎样说",
    "353": "看你[一-龥]{1,2}的|瞧他[一-龥]{1,2}的",
    "354": "真有(你|他|她)的",
    "355": "([一-龥]{1,2})什么\\1",
    "356": "什么([一-龥]{1,2})不\\1的*",
    "383": "或[一-龥]或[一-龥]",
    "384": "无[一-龥]无[一-龥]",
    "385": "[一-龥]这[一-龥]那",
    "386": "左[一-龥]右[一-龥]",
    "387": "不怎么",
    "388": "不怎么样",
    "389": "好不*容易",
    "390": "那倒也*是",
    "391": "就是说|这就是说",
    "392": "算了",
    "394": "东一([一-龥]+)，西一\\1",
    "395": "为了.+而.+",
    "400": "时而.+，时而.+",
    "401": "一时.+一时.+",
    "402": ".+便.+",
    "403": "(不但不|不但没有).+，反而.+",
    "404": "不是.+，(还|还是).+",
    "405": "连.+(都|也).+，.+更.+",
    "406": "要么.+，要么.+",
    "407": "虽.+，(但|可|却|也).+",
    "408": ".+，(要不然|不然).+",
    "409": "凡是.+，都.+",
    "410": "(就算|就是).+也.+",
    "411": "不.+不.+",
    "414": "[一-龥]{1,2}到[一-龥]{1,2}头上来了",
    "415": "([一-龥]+)就\\1吧",
    "416": "([一-龥]+)是\\1",
    "417": "不([一-龥]+)不.+，一\\1.+",
    "418": "好你个[一-龥]{1,2}",
    "420": "早也*不([一-龥]+)，晚也*不\\1",
    "422": "放着[一-龥]{1,2}不[一-龥]{1,2}",
    "423": "([一-龥]+)来\\1去，(都是|就是).+",
    "424": "([一-龥]+)了就\\1了，没*有.+",
    "425": "这也不[一-龥]{1,2}，那也不[一-龥]{1,2}|那也不[一-龥]{1,2}，这也不[一-龥]{1,2}",
    "436": "爱([一-龥])不\\1",
    "437": "半[一-龥]半[一-龥]",
    "438": "东[一-龥]西[一-龥]",
    "439": "非[一-龥]非[一-龥]",
    "440": "忽[一-龥]忽[一-龥]",
    "441": "连[一-龥]带[一-龥]",
    "442": "时[一-龥]时[一-龥]",
    "443": "自[一-龥]自[一-龥]",
    "444": "巴不得",
    "445": "别提了",
    "446": "除此之外",
    "447": "归根到底",
    "448": "可不是",
    "449": "没说的",
    "450": "无论如何",
    "451": "由此可见",
    "452": "不知.+好",
    "453": "所谓.+就是.+",
    "454": "(无非|不过|只不过|只是).+(而已|罢了)",
    "455": "以.+为.+",
    "456": "因.+而.+",
    "463": "一面.+，一面.+",
    "464": ".+，此后.+",
    "465": "起初.+，.+才.+",
    "466": "别说.+，连.+(也|都).+|连.+(也|都).+，别说.+|别说.+， 即使.+也.+|即使.+也.+，别说.+",
    "467": ".+，况且.+",
    "468": "连.+，更不用说.+",
    "469": ".+，乃至.+",
    "470": ".+，且.+",
    "471": ".+，甚至于.+",
    "472": "或.+，或.+",
    "473": "(宁可|宁愿).+，也.+",
    "474": "与其.+，不如.+",
    "475": "与其.+，(宁可|宁愿).+",
    "476": ".+，而.+则*.+",
    "477": ".+，.+(倒|反倒).+",
    "478": "(倘若|若).+，.+",
    "479": "(倘若|假设|假使|若).+，(就|那么*).+",
    "480": "幸亏.+，(要不然|不然|要不|否则).+",
    "481": "别管.+，都.+",
    "482": "任.+，也.+",
    "483": "因*.+，故.+",
    "484": "鉴于.+，.+",
    "485": "(由于)*.+，以致.+",
    "486": ".+，以至于.+",
    "487": "之所以.+，(是因为|是由于).+",
    "488": "固然.+，也.+",
    "489": ".+固然.+，(但是|可是|不过).+",
    "490": "即便.+，也.+",
    "491": "虽说.+，(但是|可是|不过).+",
    "492": "纵然.+，也.+",
    "493": ".+，以.+",
    "494": ".+，(以免|免得).+",
    "495": ".+，也就是说.+",
    "500": "(不过|但|可是)话又说回来，.+",
    "501": "([一-龥]+)也*不是，不\\1也不是",
    "502": "[一-龥]+(也好|也罢)，[一-龥]+(也好|也罢)",
    "503": "([一-龥]+)了又([一-龥]+)，\\2了又\\1",
    "504": "([一-龥]+)也\\1不.+，([一-龥]+)也\\2不.+",
    "505": "别提有*多[一-龥]{1,2}了",
    "506": "不知[一-龥]{1,2}的",
    "507": "话说*是这么说，(不过|可|可是).+",
    "508": "(看|瞧)你那[一-龥]{0,2}样",
    "509": "看在[一-龥]{1,2}的面子上",
    "510": "哪有[一-龥]{1,2}这么[一-龥]{1,2}的|有[一-龥]{1,2}这样[一-龥]{1,2}的吗",
    "511": "什么[一-龥]{1,2}的[一-龥]{1,2}的",
    "512": "(说到|想到)哪儿去了",
    "513": "无所谓([一-龥]+)不\\1",
    "514": "要([一-龥]+)(有|没)\\1，要([一-龥]+)(有|没)\\2",
    "526": ".+，何况.+",
    "527": ".+，进而.+",
    "539": "与此同时",
    "540": "这样一来",
    "541": "综上所述",
    "542": "总的来说|总而言之",
}

def read_data():
    file = open("CTC2021/train_large_v2/train_large_v2.json", 'r', encoding='utf-8')
    datas = []

    for line in file.readlines():
        data = json.loads(line)
        sent = data.get("target")
        datas.append(sent)
    #print (datas)
    return datas

def matching(datas_without_cut, datas_with_cut):
    labels = []
    matches = []
    for num in range(len(datas_with_cut)):
        label = []
        match = []
        for word in datas_with_cut[num]:
            for i in word_patterns:
                if (re.search(word_patterns[i], word)):
                    label.append(int(i))
                    match.append(re.search(word_patterns[i], word).group())
                # if (int(i)>100):
                #     break
        for i in sent_patterns:
            if (re.search(sent_patterns[i], datas_without_cut[num])):
                label.append(int(i))
                match.append(re.search(sent_patterns[i], datas_without_cut[num]).group())

        labels.append(label)
        matches.append(match)
    return labels, matches

def words_matching(words, map):
    # matches = []
    label = "其他"
    for word in words.split():
        for i in word_patterns:
            if (re.search(word_patterns[i], word)):
                # labels.append(int(i))
                # matches.append(re.search(word_patterns[i], word).group())
                for key in map:
                    if int(i) in word_class_map2[key]:
                        label = key
                        break
                break
                    # if (int(i)>100):
                    #     break
    # if labels == []:
    #     labels.append(0)
    return label

def word_matching(word):
    # matches = []
    label = "0"
    for i in word_patterns:
        if (re.search(word_patterns[i], word)):
            # labels.append(int(i))
            # matches.append(re.search(word_patterns[i], word).group())
            label = i
            break
    return label

def find_label_father(label, map):
    if label == "0": superior_label = "其他"
    else:
        for key in map:
            if int(label) in word_class_map2[key]:
                superior_label = key
                break
    return superior_label

if __name__ == "__main__":
    datas_without_cut = read_data()
    datas_with_cut = np.load('datas.npy', allow_pickle=True)
    datas_with_cut = datas_with_cut.tolist()
    labels, matches = matching(datas_without_cut[:30], datas_with_cut[:30])

    dic = {
        "数据源": datas_without_cut[:30],
        "预测标签": labels,
        "匹配值": matches
    }
    df=pd.DataFrame(dic)
    df.to_excel('test.xls')